---
- hosts: all
  become: true

  tasks:
    - import_tasks: switch-common.yml
    - import_tasks: xfabric.yml

    - name: initialize switch
      nclu:
        commands:
          - add interface swp1
          - add interface swp2
          - add interface swp3
          - add interface swp4
          - add interface swp5
          - add interface swp6
        atomic: true

    - name: initialize bgp
      nclu:
        commands:
          # basic bgp setup
          - add loopback lo ip address 10.1.0.4/32
          - add bgp autonomous-system 64703
          - add bgp router-id 10.1.0.4

          # create peer-group called xfabric
          - add bgp neighbor xfabric peer-group
          
          # peer only with neighbors not in my own ASN
          - add bgp neighbor xfabric remote-as external

          # allow bgp to negotiate the extended-nexthop capability with peers
          - add bgp neighbor xfabric capability extended-nexthop

          # add fabric switches
          - add bgp neighbor swp6 interface peer-group xfabric #xf0

          # activate peering
          - add bgp ipv6 unicast neighbor xfabric activate
        atomic: true

    - name: initialize evpn
      nclu:
        commands:
          - add bgp l2vpn evpn neighbor xfabric activate
          - add bgp ipv4 unicast network 10.1.0.4/32
          - add bgp l2vpn evpn advertise-all-vni
        atomic: true
